<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta http-equiv="Content-Language" content="en-us">
<LINK REL=STYLESHEET HREF="styles.css">
<title>Menu compiler - step 3</title>
<SCRIPT LANGUAGE=Javascript SRC="menucompiler.asp?menuname=MyMenu&menufile=menudefinition.txt"></SCRIPT>
<SCRIPT LANGUAGE=Javascript>
    // On page load - Use the compiled menu - attach it to the window
    function onLoadPage() {
        external.MainMenu = MyMenu;
    }
    // On page unload - Detach the menu and clear the definitions in the collection
    function onUnloadPage() {
        external.MainMenu = null;
        external.Menus.MenuTree.Subs.Clear();
    }
    // A sample menu click handler
    function SampleHandler(sender) {
        alert("Hello from the SampleHandler\n" + "You have clicked menu item: " + sender.Caption);
    }
</SCRIPT>
<base target="_top">
</head>

<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" onLoad="onLoadPage()" onUnload="onUnloadPage()">

<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
  <tr>
    <td width="100%" class="bigfnt" bgcolor="#000000"><font color="#FFFF00">Active
      </font><font color="#FF0000">Local</font> <font color="#FFFFFF">Pages</font></td>
  </tr>
  <tr>
    <td width="100%" height="100%" valign="top">
      <h3>ALPFrame menu compiler - step 3</h3>
      <blockquote>
      <p><b>Preview the menu</b></p>
      <p>If that page opens with a script error - that means the menu
      compilation is not successful. If so return to the <b><a href="step2.asp">previous
      step</a></b>.</p>
      <p>Here the menu is attached to the main window, but also it can be used
      as context menu (on the next step).
      <p><b>Using it in the page:</b></p>
      <p>To use the menu definition in your pages you must load the Javascript
      generated by the compiler. By setting the compiler somewhere on your
      site/application you are able to compile the menu definitions at run-time.
      Thus you need a line like this in your page:
      <p>&lt;SCRIPT LANGUAGE=Javascript SRC=&quot;<b>menucompiler.asp</b>?<font color="#008000"><b>menuname</b>=<b>MyMenu</b></font>&amp;<font color="#008080"><b>menufile</b>=<b>menudefinition.txt</b></font>&quot;&gt;&lt;/SCRIPT>
      <p>That line loads a script through the menu definition compiler (<b>menucompiler.asp</b>).
      Parameters passed to the compiler are important:
      <p><b>menuname</b> - specifies what variable to be defined for the
      generated menu. Then you are able to pass it to the <b>external.MainMenu</b>
      to set the window menu.
      <p><b>menufile</b> - is the virtual or relative path to your menu
      definition file.
      <p><b>What else you must do ?</b>&nbsp;
      <p>You need to show the menu somewhere - in this case as window menu. To
      do so you must define handlers for the <b>onLoad</b> and <b>onUnlload</b>
      events of the BODY element of the page (or FRAMESET element if the page
      contains only frame definitions). For example:
      <p><font color="#008000">&lt;body onLoad="onLoadPage()" onUnload=&quot;onUnloadPage()&quot;&gt;</font>
      <p>And here are the sample functions to handle those events:
      <p><font color="#008080">// On page load - Use the compiled menu - attach it to the window<br>
      function onLoadPage() {<br>
      &nbsp; external.MainMenu = MyMenu;<br>
    }<br>
    // On page unload - Detach the menu and clear the definitions in the collection<br>
    function onUnloadPage() {<br>
      &nbsp; external.MainMenu = null;<br>
      &nbsp; external.Menus.MenuTree.Subs.Clear();<br>
    }</font><p>It is important to clean up all the manus when the page unloads.
      If you forget to do so window menu will remain on the screen but it will
      not be applicable for the next page. For example <b>menu handler functions</b>
      may not exist in the next page.<p><b>What are the menu handler functions?</b><p>In
      the step 1 you wrote a menu definition file. ITEM and ACCELERATED ITEM (<a href="syntax.htm" target="_blank">see
      the syntax</a>) statements there contain a parameter called handler. This
      is the function that will be called when the menu item have been clicked.
      For example this page defines a function SampleHandler:<p><font color="#008080">function SampleHandler(sender) {<br>
      &nbsp; alert("Hello from the SampleHandler\n" + "You have clicked menu item: " + sended.Caption);<br>
    }</font><p>The name specified in the menu definition statement for the
      handler parameter corresponds to the handler function name. Handler
      function receives one parameter - the object representing the clicked menu
      item. You can extract from it the information you need. For example <b>Info</b>
      field in the menu definition statements becomes a value of the <b>.Info</b>
      property of the menu item object passed to your handler function(s). Thus
      you use it to specify information that your handler uses to determine the
      action it must perform or just as additional parameter if you prefer to
      connect separate handler function for every menu item.<p>If the handler
      function is not found or failed because of some other reason ALPFrame will
      display a warning message. It is always good idea to perform testing
      before deploying your application. Ensure all the items have a handler
      function and check if the menu is displayed and cleared properly.
      Forgetting to clear the window menu may cause the next page to show errors
      if it is not intended to run with this menu.<p>Go to <b><a href="step4.asp">step
      4 </a></b>- it shows the same menu as popup menu.&nbsp;
      </blockquote>
    </td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#000000" valign="middle" align="right"><font color="#FFFFFF">Copyright
      2001 newObjects</font></td>
  </tr>
</table>

</body>

</html>
