<%@ Language=VBScript %>
<%

Class CUpload
    Public postStream
    Public Post
    Private sf
    
    ' Constructors
    Private Sub Class_Initialize()
        Set sf = Server.CreateObject("newObjects.utilctls.SFMain")
        Set postStream = sf.CreateMemoryStream
        postStream.WriteBin Request.BinaryRead(Request.TotalBytes)
        postStream.Pos = 0
        postStream.unicodeText = False
        Set Post = Server.CreateObject("newObjects.utilctls.VarDictionary")
        Post.itemsAssignmentAllowed = True
        Post.Missing = Empty
        BuildUploadRequest
    End Sub
    Private Sub Class_Terminate()
        Set postStream = Nothing
        Set sf = Nothing
        Set Post = Nothing
    End Sub
    
    ' Private mambers
    Private Function MaxNum(a,b)
        If a >= b Then MaxNum = a Else MaxNum = b
    End Function
    Private Function FindColonThroughQuotes(str,beg)
        Dim qPos, cPos
        Dim pos, qOpened
        
        pos = beg
        qOpened = False

        Do
            If qOpened Then
                qPos = MaxNum(InStr(pos,str,""""),InStr(pos,str,"'"))
                If qPos = 0 Then
                    ' In fact this is an error but we will ignore it anyway
                    ' If you want to be more prcise put here an error raising code
                    FindColonThroughQuotes = Len(str) + 1
                    Exit Function
                Else
                    pos = qPos + 1
                    qOpened = False
                End If
            Else
                qPos = MaxNum(InStr(pos,str,""""),InStr(pos,str,"'"))
                cPos = InStr(pos,str,";")
                If qPos = 0 Then
                    If cPos > 0 Then
                        FindColonThroughQuotes = cPos
                    Else
                        FindColonThroughQuotes = Len(str) + 1
                    End If
                    Exit Function
                End If
                If cPos <= qPos Then
                    If cPos > 0 Then
                        FindColonThroughQuotes = cPos
                    Else
                        FindColonThroughQuotes = Len(str) + 1
                    End If
                    Exit Function
                End If
                
                qOpened = True
                pos = qPos + 1
            End If
        Loop
        
    End Function
    Private Sub ProcessContentType(content,field)
        Dim n
        n = FindColonThroughQuotes(content,1)
        field("ContentType") = Trim(Left(content,n - 1))
    End Sub
    Private Function StripQuotes(str)
        If Left(str,1) = """" Or Left(str,1) = "'" Then
            StripQuotes = Mid(str,2,Len(str) - 2)
        Else
            StripQuotes = str
        End If
    End Function
    Private Sub ProcessContentDisposition(content,field)
        Dim n, cnt, cur, t
        cnt = content
        n = 0
        
        Do 
            n = FindColonThroughQuotes(cnt,1)
            cur = Trim(Left(cnt,n - 1))
            If cur = "" Then Exit Sub
            t = InStr(cur,"=")
            If t > 0 Then
                Select Case UCase(Left(cur,t - 1))
                    Case "NAME"
                        field("Name") = StripQuotes(Mid(cur,t+1,Len(cur) - t))
                    Case "FILENAME"
                        field("RawFileName") = StripQuotes(Mid(cur,t+1,Len(cur) - t))
                        field("FileName") = sf.GetFileName(field("RawFileName"))
                        field("FileNameExtension") = sf.GetExtensionName(field("RawFileName"))
                        field("IsFile") = True
                End Select
            End If
            cnt = Mid(cnt,n+1)
        Loop
    End Sub
    Private Sub ProcessHeader(line, field)
        Dim headName, n, headContent
        n = InStr(line,":")
        If n = 0 Then Err.Raise 2,"CUpload", "Invalid header: " & line
        headName = Trim(Left(line, n -1))
        headContent = Mid(line,n + 1, Len(line) - n)
        Select Case UCase(headName)
            Case "CONTENT-TYPE"
                ProcessContentType headContent, field
            Case "CONTENT-DISPOSITION"
                ProcessContentDisposition headContent, field
            Case Else
                field.Add headName, headContent
        End Select
    End Sub
    Private Sub BuildUploadRequest()
        ' Determine the boundary (it is the first line)
        Dim boundary, eolSequence, eolLength
        boundary = postStream.ReadText(-3)
        If boundary = "" Then Err.Raise 1, "CUpload", "Incorrect post encoding"
        ' Determine the end-of-line
        eolLength = postStream.Pos - Len(boundary)
        postStream.Pos = Len(boundary)
        eolSequence = postStream.ReadText(eolLength)
        postStream.textLineSeparator = eolSequence
          
        ' Loop through the fields
        Dim line ' The current line
        Dim nextLine ' The next line
        Dim field ' The current field
        Dim coll, temp
        Do
            ' Create a node holder for the element/field
            Set field = Post.CreateNew
            field.firstItemAsRoot = True
            field.Add "Value", Empty
            field("IsFile") = False
            ' Loop through the headers
            line = postStream.ReadText(-1)
            While line <> ""
                ' Read next line
                nextLine = postStream.ReadText(-1)
                ' The headers support hiphenation (not happens with IE but it is possible with other browsers)
                While Left(nextLine,1) = vbTab Or Left(nextLine,1) = " "
                    line = line & nextLine
                    nextLine = postStream.ReadText(-1)
                Wend
                ' Here we have the full line
                ProcessHeader line, field
                line = nextLine
            Wend
            ' Headers ended - the content follows
            ' Find the end
            field("ContentBegin") = postStream.Pos
            field("ContentEnd") = postStream.Find(boundary,2) - Len(boundary) - eolLength
            field("ContentLength") = field("ContentEnd") - field("ContentBegin")
            
            ' Set the value
            
            If field("IsFile") Then
                temp = postStream.Pos
                postStream.Pos = field("ContentBegin")
                field("Value") = postStream.ReadBin(field("ContentLength"))
                postStream.Pos = temp
            Else
                temp = postStream.Pos
                postStream.Pos = field("ContentBegin")
                field("Value") = postStream.ReadText(field("ContentLength"))
                postStream.Pos = temp
            End IF
            
            If IsEmpty(Post(field("Name"))) Then
                Set coll = Post.CreateNew
                coll.firstItemAsRoot = True
                coll.allowUnnamedValues = True
                coll.Add "", field
                Post.Add field("Name"), coll
            Else
                Post(field("Name")).Add "", field
            End If
            
            line = postStream.ReadText(-1)
            If line = "--" Then
                ' This is end of the upload
                Exit Do
            End If            
        Loop
        Set postStream = Nothing
    End Sub
    
    ' Public members
    Public Default Property Get Value
        Set Value = Post
    End Property
End Class


    Dim sf, dir
    Set sf = Server.CreateObject("newObjects.utilctls.SFMain")
    Dim exist
    exist = sf.Exists(Server.MapPath("uploads"))
    If exist = 0 Then
        ' Dows not exist
        Set dir = sf.CreateDirectory(Server.MapPath("uploads"))
    ElseIf exist = 1 Then
        Err.Raise 1,"Upload sample", "A file named upload already exists - cannot create directory"
    Else
        Set dir = sf.OpenDirectory(Server.MapPath("uploads"))
    End If
    
    Dim message
    message = ""
    If Request.ServerVariables("REQUEST_METHOD") = "POST" Then
        Set upl = New CUpload
        Set Post = upl.Value
        If Post("File").Count > 0 Then
            Set F = Post("File")(1)
            Set target = dir.CreateStream(F("FileName"))
            target.WriteBin F("Value")
            Set target = Nothing ' close the file
            message = "File " & F("FileName") & " has been saved as: " & Server.MapPath("uploads\" & F("FileName"))
        End IF
    End If
    
%>

<html>

<head>
<meta name="GENERATOR" content="newObjects ALP 1.0">
<link REL="stylesheet" HREF="/styles.css">
<title>Active Local Pages 1.1</title>
</head>

<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0">
<!-- #include virtual="/templates/aspsamples-head.inc" -->

<!-- Code begin -->
The file will be saved in a subdirectory named UPLOADS. The ASP page will create it 
if it does not exist.
<FORM METHOD="POST" ACTION="<%= Request.ServerVariables("SCRIPT_NAME") %>" enctype="multipart/form-data">
    Choose the file: <INPUT TYPE="FILE" NAME="File" VALUE=""><BR>
    <INPUT TYPE="SUBMIT" NAME="Btn" Value="Upload">
</FORM>
<A TARGET="_blank" HREF="file://<%= Server.MapPath("uploads\") %>"><%= Server.HTMLEncode(message) %></A>
<!-- Code end -->

<!-- #include virtual="/templates/aspsamples-footer.inc" -->
</body>
</html>


